package com.landray.kmss.sys.attachment.service.spring;

import com.landray.kmss.sys.attachment.plugin.wpsAddons.util.SysAttachmentWpsAddonsLockUtils;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsoaassistUtil;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import com.landray.kmss.sys.cache.KmssCache;
import com.landray.kmss.sys.cache.CacheConfig;
import com.landray.kmss.sys.filestore.location.interfaces.ISysFileLocationProxyService;
import org.springframework.transaction.TransactionStatus;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.util.TransactionUtils;
import com.landray.kmss.sys.attachment.util.SysAttConfigUtil;
import com.landray.kmss.sys.attachment.integrate.wps.util.SysAttWpsCenterUtil;
import com.landray.kmss.sys.attachment.plugin.HistoryVersionPluginData;
import java.util.Map;
import com.landray.kmss.sys.attachment.plugin.HistoryVersionPlugin;
import com.sunbor.web.tag.Page;
import com.landray.kmss.constant.SysAuthConstant;
import com.landray.kmss.sys.filestore.model.SysAttFile;
import com.landray.kmss.sys.filestore.model.SysAttFileBak;
import org.apache.commons.io.FileUtils;
import com.landray.kmss.sys.filestore.model.SysAttCatalog;
import com.landray.kmss.common.dao.HQLInfo;
import com.landray.kmss.common.model.IBaseModel;
import org.springframework.beans.BeanUtils;
import java.util.Iterator;
import java.util.List;
import com.landray.kmss.sys.attachment.model.SysAttMainBak;
import java.util.Collections;
import java.util.Collection;
import org.apache.commons.collections.CollectionUtils;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import java.util.ArrayList;
import java.util.Date;
import java.util.Calendar;
import com.landray.kmss.sys.filestore.location.util.SysFileLocationUtil;
import java.io.IOException;
import org.apache.commons.lang3.StringUtils;
import java.io.File;
import com.landray.kmss.util.ResourceUtil;
import com.landray.kmss.sys.attachment.model.SysAttMainHistoryConfig;
import org.slf4j.LoggerFactory;
import com.landray.kmss.sys.quartz.interfaces.SysQuartzJobContext;
import com.landray.kmss.sys.filestore.service.ISysAttUploadService;
import com.landray.kmss.sys.filestore.service.ISysAttFileBakService;
import com.landray.kmss.sys.attachment.service.ISysAttMainBakService;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import org.slf4j.Logger;
import com.landray.kmss.sys.attachment.service.ISysAttClearService;

public class SysAttClearServiceImpl implements ISysAttClearService
{
    protected static final Logger logger;
    public static final long gap = 60000L;
    private ISysAttMainCoreInnerService sysAttMainService;
    private ISysAttMainBakService sysAttMainBakService;
    private ISysAttFileBakService sysAttFileBakService;
    protected ISysAttUploadService sysAttUploadService;
    private SysQuartzJobContext context;
    
    static {
        logger = LoggerFactory.getLogger(SysAttClearServiceImpl.class);
    }
    
    public void setSysAttMainService(final ISysAttMainCoreInnerService sysAttMainService) {
        this.sysAttMainService = sysAttMainService;
    }
    
    public void setSysAttMainBakService(final ISysAttMainBakService sysAttMainBakService) {
        this.sysAttMainBakService = sysAttMainBakService;
    }
    
    public void setSysAttFileBakService(final ISysAttFileBakService sysAttFileBakService) {
        this.sysAttFileBakService = sysAttFileBakService;
    }
    
    public void setSysAttUploadService(final ISysAttUploadService sysAttUploadService) {
        this.sysAttUploadService = sysAttUploadService;
    }
    
    public String getDestRoot() throws Exception {
        String destRoot = null;
        final SysAttMainHistoryConfig config = new SysAttMainHistoryConfig();
        final String rootType = config.getRootType();
        if ("0".equals(rootType)) {
            destRoot = ResourceUtil.getKmssConfigString("kmss.resource.path").replaceAll("\\\\", "/");
            if (!destRoot.endsWith("/")) {
                destRoot = String.valueOf(destRoot) + "/";
            }
            destRoot = String.valueOf(destRoot) + "temphistoryatt";
        }
        else {
            destRoot = config.getRootPath().replaceAll("\\\\", "/");
            if (destRoot.endsWith("/")) {
                destRoot = destRoot.substring(0, destRoot.length() - 1);
            }
            final File temp = new File(destRoot);
            try {
                final String path = temp.getCanonicalPath().replaceAll("\\\\", "/");
                if (!StringUtils.equals(path, destRoot)) {
                    throw new RuntimeException(String.valueOf(config.getRootPath()) + " 不是有效的绝对路径，识别为 " + path);
                }
            }
            catch (final IOException ex) {
                throw new RuntimeException(String.valueOf(config.getRootPath()) + " 不是有效的绝对路径");
            }
        }
        final File dir = new File(destRoot);
        if (!dir.exists() && !dir.mkdirs()) {
            throw new RuntimeException(String.valueOf(destRoot) + " 不是正常路径或没有读写权限");
        }
        return destRoot;
    }
    
    public void moveHisAttachments(final SysQuartzJobContext context) {
        (this.context = context).logMessage("定时移出附件历史版本开始");
        final long start = System.currentTimeMillis();
        try {
            final SysAttMainHistoryConfig config = new SysAttMainHistoryConfig();
            if (!"true".equals(config.getAttClearEnable())) {
                context.logMessage("定时移出附件历史版本中止，未开启开关");
                return;
            }
            final String key = SysFileLocationUtil.getKey((String)null);
            if (!"server".equals(key)) {
                context.logMessage("定时移出附件历史版本中止，附件存储类型是云存储");
                return;
            }
            try {
                this.getDestRoot();
            }
            catch (final Exception e) {
                context.logMessage("定时移出附件历史版本中止，" + e.getMessage());
                return;
            }
            final Integer days = Integer.valueOf(config.getAttKeepDays());
            final Calendar calendar = Calendar.getInstance();
            calendar.setTime(new Date());
            calendar.set(11, 0);
            calendar.set(12, 0);
            calendar.set(13, 0);
            calendar.set(14, 0);
            calendar.add(6, days);
            final Date movingTime = calendar.getTime();
            final Integer count = Integer.valueOf(config.getAttClearCount());
            final List<SysAttMain> toDelList2 = new ArrayList<SysAttMain>();
            final List<SysAttMain> toMoveList2 = new ArrayList<SysAttMain>();
            long s = System.currentTimeMillis();
            this.getToMove2(count, toDelList2, toMoveList2);
            context.logMessage("查询没有启用版本管理的附件，cost = " + (System.currentTimeMillis() - s));
            s = System.currentTimeMillis();
            this.addBak(toDelList2, movingTime);
            context.logMessage("待移出的主文档备份到bak表，size=" + toDelList2.size() + "，cost = " + (System.currentTimeMillis() - s));
            s = System.currentTimeMillis();
            List<SysAttMainBak> sysAttMainBaks = this.selectBakToMoving();
            if (CollectionUtils.isEmpty((Collection)sysAttMainBaks)) {
                sysAttMainBaks = Collections.EMPTY_LIST;
            }
            context.logMessage("查询bak表当前可以移出的主文档记录，size=" + sysAttMainBaks.size() + "，cost = " + (System.currentTimeMillis() - s));
            if (!CollectionUtils.isEmpty((Collection)sysAttMainBaks)) {
                s = System.currentTimeMillis();
                for (final SysAttMainBak bak : sysAttMainBaks) {
                    this.move(bak);
                }
                context.logMessage("移动处理完成，cost = " + (System.currentTimeMillis() - s));
            }
        }
        catch (final Exception e2) {
            context.logError("定时移出附件历史版本执行异常", (Throwable)e2);
        }
        context.logMessage("定时移出附件历史版本结束，cost = " + (System.currentTimeMillis() - start));
    }
    
    private void addBak(final List<SysAttMain> list, final Date movingTime) throws Exception {
        if (CollectionUtils.isEmpty((Collection)list)) {
            return;
        }
        for (final SysAttMain attMain : list) {
            final SysAttMainBak bak = new SysAttMainBak();
            BeanUtils.copyProperties((Object)attMain, (Object)bak);
            bak.setFdMovingTime(movingTime);
            this.sysAttMainBakService.getBaseDao().add((IBaseModel)bak);
            this.sysAttMainService.getSysAttMainDao().delete((IBaseModel)attMain);
        }
    }
    
    private List<SysAttMainBak> selectBakToMoving() throws Exception {
        final HQLInfo hqlInfo = new HQLInfo();
        final String where = " fdMovingStatus=:fdMovingStatus and fdMovingTime<:fdMovingTime";
        hqlInfo.setWhereBlock(where);
        hqlInfo.setParameter("fdMovingStatus", (Object)0);
        hqlInfo.setParameter("fdMovingTime", (Object)new Date());
        hqlInfo.setAuthCheckType("SYS_NONE");
        hqlInfo.setOrderBy("docCreateTime");
        return this.sysAttMainBakService.getBaseDao().findList(hqlInfo);
    }
    
    private String getRoot(final SysAttCatalog sysAttCatalog) {
        String root = ResourceUtil.getKmssConfigString("kmss.resource.path").replaceAll("\\\\", "/");
        if (sysAttCatalog != null) {
            root = sysAttCatalog.getFdPath().replaceAll("\\\\", "/");
        }
        if (root.endsWith("/")) {
            root = root.substring(0, root.length() - 1);
        }
        return root;
    }
    
    private void move(final SysAttMainBak bak) throws Exception {
        final SysAttFile attFile = this.sysAttUploadService.getFileById(bak.getFdFileId());
        if (attFile == null) {
            bak.setFdMovingStatus(2);
            this.sysAttMainBakService.getBaseDao().update((IBaseModel)bak);
            this.context.logMessage("fdId = " + bak.getFdId() + " 关联的文件在att_file表不存在");
        }
        else {
            final String root = this.getRoot(attFile.getFdCata());
            final String filePath = String.valueOf(root) + attFile.getFdFilePath();
            final File file = new File(filePath);
            if (!file.exists()) {
                bak.setFdMovingStatus(3);
                this.sysAttMainBakService.getBaseDao().update((IBaseModel)bak);
                this.context.logMessage("fdId = " + bak.getFdId() + " 的物理文件 " + filePath + " 不存在");
            }
            else {
                final String destRoot = this.getDestRoot();
                final String destPath = String.valueOf(destRoot) + attFile.getFdFilePath();
                final File destFile = new File(destPath);
                if (destFile.exists()) {
                    destFile.delete();
                }
                FileUtils.moveFile(file, destFile);
                final String parentPath = file.getParentFile().getCanonicalPath();
                final File convert = new File(parentPath, String.valueOf(bak.getFdFileId()) + "_convert");
                if (convert.exists()) {
                    final File destConvert = new File(destFile.getParentFile().getCanonicalPath(), String.valueOf(bak.getFdFileId()) + "_convert");
                    if (!destConvert.exists()) {
                        destConvert.mkdirs();
                    }
                    FileUtils.copyDirectory(convert, destConvert);
                    FileUtils.deleteQuietly(convert);
                }
                final File bakFile = new File(parentPath, String.valueOf(bak.getFdFileId()) + "_bak");
                if (bakFile.exists()) {
                    final File destBak = new File(destFile.getParentFile().getCanonicalPath(), String.valueOf(bak.getFdFileId()) + "_bak");
                    if (destBak.exists()) {
                        destBak.delete();
                    }
                    FileUtils.moveFile(bakFile, destBak);
                }
                bak.setFdMovingStatus(1);
                this.sysAttMainBakService.getBaseDao().update((IBaseModel)bak);
                final SysAttFileBak fileBak = new SysAttFileBak();
                BeanUtils.copyProperties((Object)attFile, (Object)fileBak);
                this.sysAttFileBakService.getBaseDao().add((IBaseModel)fileBak);
                this.sysAttUploadService.deleteRecord(attFile.getFdId());
            }
        }
    }
    
    private void getToMove1(final Integer count, final List<SysAttMain> list, final List<SysAttMain> toMoveList) throws Exception {
        final String whereBlock = " fdModelId is null ";
        final HQLInfo hqlInfo = new HQLInfo();
        hqlInfo.setPageNo(1);
        hqlInfo.setRowSize((int)count);
        hqlInfo.setCheckParam((Enum)SysAuthConstant.CheckType.AllCheck, (Object)SysAuthConstant.AllCheck.NO);
        hqlInfo.setWhereBlock(whereBlock);
        hqlInfo.setOrderBy("docCreateTime asc");
        final Page page = this.sysAttMainService.findPage(hqlInfo);
        list.addAll(page.getList());
        for (final SysAttMain att : list) {
            final String where = " fdModelId is not null and fdFileId = :fdFileId";
            final HQLInfo hql = new HQLInfo();
            hql.setCheckParam((Enum)SysAuthConstant.CheckType.AllCheck, (Object)SysAuthConstant.AllCheck.NO);
            hql.setGetCount(true);
            hql.setWhereBlock(where);
            hql.setParameter("fdFileId", (Object)att.getFdFileId());
            final Page p = this.sysAttMainService.findPage(hql);
            if (p.getTotalrows() < 1) {
                toMoveList.add(att);
            }
        }
    }
    
    private void getToMove2(final Integer count, final List<SysAttMain> list, final List<SysAttMain> toMoveList) throws Exception {
        final List<String> exModels = new ArrayList<String>();
        int len = 0;
        if ("true".equals(SysAttMainHistoryConfig.newInstance().getAttHistoryEnable())) {
            final Map<String, HistoryVersionPluginData> enabledModules = HistoryVersionPlugin.getEnabledModules();
            if (enabledModules != null) {
                for (final String m : enabledModules.keySet()) {
                    exModels.add(m);
                }
                len = exModels.size();
            }
        }
        final StringBuilder sb = new StringBuilder();
        sb.append(" fdKey='historyVersionAttachment' and fdModelId is not null ");
        if (CollectionUtils.isNotEmpty((Collection)exModels)) {
            sb.append(" and fdModelName not in (");
            for (final String model : exModels) {
                sb.append("'").append(model).append("'");
                if (--len != 0) {
                    sb.append(",");
                }
            }
            sb.append(")");
        }
        final HQLInfo hqlInfo = new HQLInfo();
        hqlInfo.setRowSize((int)count);
        hqlInfo.setCheckParam((Enum)SysAuthConstant.CheckType.AllCheck, (Object)SysAuthConstant.AllCheck.NO);
        hqlInfo.setWhereBlock(sb.toString());
        hqlInfo.setOrderBy("docCreateTime");
        final Page page = this.sysAttMainService.findPage(hqlInfo);
        list.addAll(page.getList());
        toMoveList.addAll(page.getList());
    }
    
    public void delHisAttachments() {
        final Calendar c = Calendar.getInstance();
        c.setTime(new Date());
    }
    
    public void delWpsCenterHisAttachments(final SysQuartzJobContext context) {
        TransactionStatus status = null;
        try {
            if (!SysAttWpsCenterUtil.isEnable() && !SysAttConfigUtil.isWpsCenterV6Enabled()) {
                return;
            }
            status = TransactionUtils.beginNewTransaction();
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setRowSize(500);
            hqlInfo.setAuthCheckType("SYS_NONE");
            hqlInfo.setCheckParam((Enum)SysAuthConstant.CheckType.AreaCheck, (Object)SysAuthConstant.AreaCheck.NO);
            hqlInfo.setWhereBlock("sysAttMain.fdKey = :fdKey");
            hqlInfo.setParameter("fdKey", (Object)"WPSCenterSelfAttachment");
            final Page page = this.sysAttMainService.findPage(hqlInfo);
            final List<SysAttMain> attList = page.getList();
            for (final SysAttMain att : attList) {
                if (StringUtil.isNotNull(att.getFdFileId())) {
                    if (this.hasMoreAttMain(att)) {
                        try {
                            this.sysAttMainService.delete(att.getFdId());
                        }
                        catch (final Exception e) {
                            SysAttClearServiceImpl.logger.error("删除记录失败：" + att.getFdId(), e);
                        }
                    }
                    else {
                        final SysAttFile attFile = this.sysAttUploadService.getFileById(att.getFdFileId());
                        if (attFile == null) {
                            continue;
                        }
                        Boolean delData = true;
                        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
                        try {
                            sysFileLocationService.deleteFile(attFile.getFdFilePath());
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除文件失败：" + att.getFdFileId(), e2);
                            delData = false;
                        }
                        try {
                            sysFileLocationService.deleteDirectory(String.valueOf(attFile.getFdFilePath()) + "_convert");
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除转换目录失败：" + att.getFdFileId() + "_convert", e2);
                            delData = false;
                        }
                        if (!delData) {
                            continue;
                        }
                        try {
                            this.sysAttUploadService.deleteRecord(att.getFdFileId());
                            this.sysAttMainService.delete(att.getFdId());
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除记录失败：" + att.getFdFileId() + " - " + att.getFdId(), e2);
                        }
                    }
                }
            }
            if (page.getTotal() > 1) {
                for (int o = 2; o <= page.getTotal(); ++o) {
                    hqlInfo.setPageNo(o);
                    final Page pageNext = this.sysAttMainService.findPage(hqlInfo);
                    final List<SysAttMain> attNextList = pageNext.getList();
                    for (final SysAttMain att2 : attNextList) {
                        if (StringUtil.isNotNull(att2.getFdFileId())) {
                            if (this.hasMoreAttMain(att2)) {
                                try {
                                    this.sysAttMainService.delete(att2.getFdId());
                                }
                                catch (final Exception e2) {
                                    SysAttClearServiceImpl.logger.error("删除记录失败：" + att2.getFdId(), e2);
                                }
                            }
                            else {
                                final SysAttFile attFile2 = this.sysAttUploadService.getFileById(att2.getFdFileId());
                                if (attFile2 == null) {
                                    continue;
                                }
                                Boolean delData2 = true;
                                final ISysFileLocationProxyService sysFileLocationService2 = SysFileLocationUtil.getProxyService(attFile2.getFdAttLocation());
                                try {
                                    sysFileLocationService2.deleteFile(attFile2.getFdFilePath());
                                }
                                catch (final Exception e3) {
                                    SysAttClearServiceImpl.logger.error("删除文件失败：" + att2.getFdFileId(), e3);
                                    delData2 = false;
                                }
                                try {
                                    sysFileLocationService2.deleteDirectory(String.valueOf(attFile2.getFdFilePath()) + "_convert");
                                }
                                catch (final Exception e3) {
                                    SysAttClearServiceImpl.logger.error("删除转换目录失败：" + att2.getFdFileId() + "_convert", e3);
                                    delData2 = false;
                                }
                                if (!delData2) {
                                    continue;
                                }
                                try {
                                    this.sysAttUploadService.deleteRecord(att2.getFdFileId());
                                    this.sysAttMainService.delete(att2.getFdId());
                                }
                                catch (final Exception e3) {
                                    SysAttClearServiceImpl.logger.error("删除记录失败：" + att2.getFdFileId() + " - " + att2.getFdId(), e3);
                                }
                            }
                        }
                    }
                }
            }
            TransactionUtils.commit(status);
        }
        catch (final Exception e4) {
            SysAttClearServiceImpl.logger.error("delWpsCenterHisAttachments异常: ", e4);
            if (status != null) {
                TransactionUtils.rollback(status);
            }
        }
    }
    
    public void delWpsCenterAutoSaveFiles() {
        final CacheConfig config = CacheConfig.get((Class)SysAttMainCoreInnerServiceImp.class);
        final KmssCache cache = new KmssCache((Class)SysAttMainCoreInnerServiceImp.class, config.setCacheType(3));
        final Object m = cache.get("wpsCenterSaveMark");
        if (m == null) {
            return;
        }
        final ConcurrentHashMap<String, String> map = (ConcurrentHashMap<String, String>)m;
        final Set<Map.Entry<String, String>> set = map.entrySet();
        for (final Map.Entry<String, String> en : set) {
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setAuthCheckType("SYS_NONE");
            hqlInfo.setCheckParam((Enum)SysAuthConstant.CheckType.AreaCheck, (Object)SysAuthConstant.AreaCheck.NO);
            final String whereBlock = "fdModelId=:fdModelId and fdModelName=:fdModelName and fdKey not in ('editonline','clearAtt','finalAtt','modifyAtt','originalAtt','redheadAtt','revisionAtt','revisionNodeAtt')";
            hqlInfo.setWhereBlock(whereBlock);
            hqlInfo.setParameter("fdModelId", (Object)en.getKey());
            hqlInfo.setParameter("fdModelName", (Object)en.getValue());
            hqlInfo.setOrderBy("fdUploadTime desc");
            try {
                final List<SysAttMain> list = this.sysAttMainService.findList(hqlInfo);
                this.doDel(list);
            }
            catch (final Exception e) {
                SysAttClearServiceImpl.logger.error("doDel异常: ", e);
            }
        }
        boolean stop = false;
        while (!stop) {
            final Object o = cache.get("wpsCenterSaveMarkLock");
            if (o == null) {
                cache.put("wpsCenterSaveMarkLock", (Object)"wpsCenterSaveMarkLock");
                try {
                    final Object newm = cache.get("wpsCenterSaveMark");
                    if (newm == null) {
                        break;
                    }
                    final ConcurrentHashMap newmap = (ConcurrentHashMap)newm;
                    final Iterator<String> keys = map.keySet().iterator();
                    while (keys.hasNext()) {
                        newmap.remove(keys.next());
                    }
                    cache.put("wpsCenterSaveMark", (Object)newmap);
                }
                finally {
                    cache.remove("wpsCenterSaveMarkLock");
                    stop = true;
                }
                cache.remove("wpsCenterSaveMarkLock");
                stop = true;
            }
            try {
                Thread.sleep(50L);
            }
            catch (final InterruptedException ex) {}
        }
    }
    
    private void doDel(final List<SysAttMain> list) {
        if (CollectionUtils.isEmpty((Collection)list)) {
            return;
        }
        final Map<String, List<SysAttMain>> map = new HashMap<String, List<SysAttMain>>();
        for (final SysAttMain attMain : list) {
            List<SysAttMain> data = map.get(attMain.getFdUploaderId());
            if (data == null) {
                data = new ArrayList<SysAttMain>();
                map.put(attMain.getFdUploaderId(), data);
            }
            data.add(attMain);
        }
        for (final Map.Entry<String, List<SysAttMain>> en : map.entrySet()) {
            final List<SysAttMain> li = en.getValue();
            if (!CollectionUtils.isEmpty((Collection)li)) {
                if (li.size() < 3) {
                    continue;
                }
                Collections.sort(li, new Comparator<SysAttMain>() {
                    @Override
                    public int compare(final SysAttMain arg0, final SysAttMain arg1) {
                        final long c = arg0.getFdUploadTime().getTime() - arg1.getFdUploadTime().getTime();
                        if (c > 0L) {
                            return -1;
                        }
                        if (c < 0L) {
                            return 1;
                        }
                        return 0;
                    }
                });
                final int len = li.size() - 2;
                if (len == 1) {
                    this.delete(li.get(li.size() - 1));
                }
                else {
                    for (int i = li.size() - 3; i > 0; --i) {
                        final SysAttMain m1 = li.get(i);
                        final SysAttMain m2 = li.get(i - 1);
                        final long t1 = m1.getFdUploadTime().getTime();
                        final long t2 = m2.getFdUploadTime().getTime();
                        if (t1 - t2 < 60000L) {
                            this.delete(m1);
                        }
                    }
                    this.delete(li.get(li.size() - 1));
                }
            }
        }
    }
    
    private void delete(final SysAttMain att) {
        try {
            if ("editonline".equals(att.getFdKey().trim())) {
                return;
            }
            if (!StringUtil.isNotNull(att.getFdFileId())) {
                return;
            }
            if (this.hasMoreAttMain(att)) {
                try {
                    this.sysAttMainService.delete(att.getFdId());
                }
                catch (final Exception e) {
                    SysAttClearServiceImpl.logger.error("删除记录失败：" + att.getFdId(), e);
                }
                return;
            }
            if (StringUtil.isNotNull(att.getFdFileId())) {
                final SysAttFile attFile = this.sysAttUploadService.getFileById(att.getFdFileId());
                if (attFile != null) {
                    Boolean delData = true;
                    final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
                    try {
                        sysFileLocationService.deleteFile(attFile.getFdFilePath());
                    }
                    catch (final Exception e2) {
                        SysAttClearServiceImpl.logger.error("删除文件失败：" + att.getFdFileId(), e2);
                        delData = false;
                    }
                    try {
                        sysFileLocationService.deleteDirectory(String.valueOf(attFile.getFdFilePath()) + "_convert");
                    }
                    catch (final Exception e2) {
                        SysAttClearServiceImpl.logger.error("删除转换目录失败：" + att.getFdFileId() + "_convert", e2);
                        delData = false;
                    }
                    if (delData) {
                        try {
                            this.sysAttUploadService.deleteRecord(att.getFdFileId());
                            this.sysAttMainService.delete(att.getFdId());
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除记录失败：" + att.getFdFileId() + " - " + att.getFdId(), e2);
                        }
                    }
                }
            }
        }
        catch (final Exception e) {
            SysAttClearServiceImpl.logger.error("delete执行异常，", e);
        }
    }
    
    private boolean hasMoreAttMain(final SysAttMain att) throws Exception {
        final HQLInfo hqlInfo = new HQLInfo();
        hqlInfo.setAuthCheckType("SYS_NONE");
        hqlInfo.setCheckParam((Enum)SysAuthConstant.CheckType.AreaCheck, (Object)SysAuthConstant.AreaCheck.NO);
        hqlInfo.setWhereBlock("sysAttMain.fdId != :fdId and sysAttMain.fdFileId = :fdFileId");
        hqlInfo.setParameter("fdId", (Object)att.getFdId());
        hqlInfo.setParameter("fdFileId", (Object)att.getFdFileId());
        final List<SysAttMain> attList = this.sysAttMainService.findList(hqlInfo);
        return attList.size() > 0;
    }
    
    public void delWPSOAassistEmbedHisAttachments(final SysQuartzJobContext context) {
        TransactionStatus status = null;
        try {
            if (!SysAttWpsoaassistUtil.isWPSOAassistEmbed()) {
                return;
            }
            status = TransactionUtils.beginNewTransaction();
            final HQLInfo hqlInfo = new HQLInfo();
            hqlInfo.setRowSize(100);
            hqlInfo.setAuthCheckType("SYS_NONE");
            hqlInfo.setCheckParam((Enum)SysAuthConstant.CheckType.AreaCheck, (Object)SysAuthConstant.AreaCheck.NO);
            hqlInfo.setWhereBlock("sysAttMain.fdKey = :fdKey and sysAttMain.fdModelId ='' and sysAttMain.fdModelName = '' ");
            hqlInfo.setParameter("fdKey", (Object)"tmpWpsOaassist");
            final Page page = this.sysAttMainService.findPage(hqlInfo);
            final List<SysAttMain> attList = page.getList();
            for (final SysAttMain att : attList) {
                if (StringUtil.isNotNull(att.getFdFileId())) {
                    if (this.hasMoreAttMain(att)) {
                        try {
                            this.sysAttMainService.delete(att.getFdId());
                        }
                        catch (final Exception e) {
                            SysAttClearServiceImpl.logger.error("删除记录失败：" + att.getFdId(), e);
                        }
                    }
                    else {
                        final SysAttFile attFile = this.sysAttUploadService.getFileById(att.getFdFileId());
                        if (attFile == null) {
                            continue;
                        }
                        Boolean delData = true;
                        final ISysFileLocationProxyService sysFileLocationService = SysFileLocationUtil.getProxyService(attFile.getFdAttLocation());
                        try {
                            sysFileLocationService.deleteFile(attFile.getFdFilePath());
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除文件失败：" + att.getFdFileId(), e2);
                            delData = false;
                        }
                        try {
                            sysFileLocationService.deleteDirectory(String.valueOf(attFile.getFdFilePath()) + "_convert");
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除转换目录失败：" + att.getFdFileId() + "_convert", e2);
                            delData = false;
                        }
                        if (!delData) {
                            continue;
                        }
                        try {
                            this.sysAttUploadService.deleteRecord(att.getFdFileId());
                            this.sysAttMainService.delete(att.getFdId());
                        }
                        catch (final Exception e2) {
                            SysAttClearServiceImpl.logger.error("删除记录失败：" + att.getFdFileId() + " - " + att.getFdId(), e2);
                        }
                    }
                }
            }
            if (page.getTotal() > 1) {
                for (int o = 2; o <= page.getTotal(); ++o) {
                    hqlInfo.setPageNo(o);
                    final Page pageNext = this.sysAttMainService.findPage(hqlInfo);
                    final List<SysAttMain> attNextList = pageNext.getList();
                    for (final SysAttMain att2 : attNextList) {
                        if (StringUtil.isNotNull(att2.getFdFileId())) {
                            if (this.hasMoreAttMain(att2)) {
                                try {
                                    this.sysAttMainService.delete(att2.getFdId());
                                }
                                catch (final Exception e2) {
                                    SysAttClearServiceImpl.logger.error("删除记录失败：" + att2.getFdId(), e2);
                                }
                            }
                            else {
                                final SysAttFile attFile2 = this.sysAttUploadService.getFileById(att2.getFdFileId());
                                if (attFile2 == null) {
                                    continue;
                                }
                                Boolean delData2 = true;
                                final ISysFileLocationProxyService sysFileLocationService2 = SysFileLocationUtil.getProxyService(attFile2.getFdAttLocation());
                                try {
                                    sysFileLocationService2.deleteFile(attFile2.getFdFilePath());
                                }
                                catch (final Exception e3) {
                                    SysAttClearServiceImpl.logger.error("删除文件失败：" + att2.getFdFileId(), e3);
                                    delData2 = false;
                                }
                                try {
                                    sysFileLocationService2.deleteDirectory(String.valueOf(attFile2.getFdFilePath()) + "_convert");
                                }
                                catch (final Exception e3) {
                                    SysAttClearServiceImpl.logger.error("删除转换目录失败：" + att2.getFdFileId() + "_convert", e3);
                                    delData2 = false;
                                }
                                if (!delData2) {
                                    continue;
                                }
                                try {
                                    this.sysAttUploadService.deleteRecord(att2.getFdFileId());
                                    this.sysAttMainService.delete(att2.getFdId());
                                }
                                catch (final Exception e3) {
                                    SysAttClearServiceImpl.logger.error("删除记录失败：" + att2.getFdFileId() + " - " + att2.getFdId(), e3);
                                }
                            }
                        }
                    }
                }
            }
            TransactionUtils.commit(status);
        }
        catch (final Exception e4) {
            SysAttClearServiceImpl.logger.error("delWPSOAassistEmbedHisAttachments异常: ", e4);
            if (status != null) {
                TransactionUtils.rollback(status);
            }
        }
    }
    
    public void clearWpsOaassistLocks(final SysQuartzJobContext context) {
        try {
            SysAttachmentWpsAddonsLockUtils.forceUnlock();
        }
        catch (final Exception e) {
            SysAttClearServiceImpl.logger.error("WPS加载项释放异常编辑锁失败", e);
        }
    }
}
